package main

import (
  "time"

  "github.com/spf13/viper"

  "git.metaunix.net/BitGoblin/adept/config"
  "git.metaunix.net/BitGoblin/adept/transcoder"
)

func main() {
  config.LoadConfig()

  r := transcoder.NewRepository(viper.GetString("transcoder.repository"))

  // main program loop - runs infinitely until externally terminated
  for {
    ingestFiles := r.SearchIngest()

    for _, i := range ingestFiles {
      // archive file
      r.ArchiveFile(i.Name())
      // transcode file
      transcoder.Transcode(i.Name())
      // clean up source file
      r.CleanupFile(i.Name())
    }

    // sleep for X minutes - specified in the adept.toml config file
    interval := viper.GetInt("transcoder.interval")
    time.Sleep(time.Duration(interval) * time.Minute)
  }
}
